# This file originally contained the comment:
#   Do not edit -- this file automatically generated by build_v3_dist.
# On the contrary, do not rerun build_v3_dist, this file contains
# custom changes for LSB that should not be overwritten
# upstream (gcc) version, LSB specification version, LSB release version
%define version 3.4.3
%define LSBSpec 3.1
%define LSBRelease 3

Summary:     libstdcpp-v3 testsuite packaged to be run under QMTest.
Name:        lsb-test-libstdcpp
Packager:    Nathaniel Smith <njs@codesourcery.com>
License:     Various
# This should be the gcc version
Version:     %{version}
Release:     %{rel}.lsb%{LSBRelease}
Group:       Development/Tools
BuildRoot:   %{_tmppath}/%{name}-buildroot
Source:      lsb-test-libstdcpp-%{version}.tar.gz
Patch0:      abi_check.patch
Patch1:      lsb-test-libstdcpp-3.4.3-nostdc++-dot-h.patch
Vendor:      CodeSourcery LLC
# If we let RPM detect dependencies, it will get the idea that this package
# requires a specific version of libstdc++.so, and that is unhelpful:
AutoReqProv: no
#Prefix: /opt/lsb/test
Requires: lsb-qm
BuildRequires: lsb-qm
Obsoletes: qmtest_libstdcpp
Provides: qmtest_libstdcpp

%description
This package includes the libstdc++-v3 testsuite from gcc version
%{version}, together with QMTest extensions allowing the testsuite
to be run against an installed version of libstdc++ without
requiring a compiler.

Expected test results:
Total Tests Passed: 1275

%prep
%setup -q
%patch -p1
# (sb) some archs (ia64 for one) do not like "-include bits/stdc++.h"
# build log is full of errors of duplicate definitions - get 90-some tests
# apply to all archs and see of we break anything
%patch1 -p1 -b .no-stdc++-dot-h

%build
# do not used the precompiled stdc++.h
# alternate approach to P1 - uncomment the 2 lines below, comment out P1
#mkdir testsuite/bits
#touch testsuite/bits/stdc++.h

%install
rm -rf $RPM_BUILD_ROOT

# for bugid 982
mv qm-classes/qmtest_gcc/v3_database.py qm-classes/qmtest_gcc/v3_database.py.SAV
sed -e "s/return result + \[\"v3_abi_test\"]/return result/" qm-classes/qmtest_gcc/v3_database.py.SAV > qm-classes/qmtest_gcc/v3_database.py
rm -f qm-classes/qmtest_gcc/v3_database.py.SAV

# We do the building first, because some of the files generated will be
# installed later.
PATH=$PATH:/opt/lsb/bin:/opt/lsb/appbat/bin
PKGROOT=/opt/lsb/test/libstdcpp_%{version}
%ifarch ppc64 s390x x86_64
  EXECROOT=/opt/lsb/test/lib64/libstdcpp_%{version}
%else
  EXECROOT=/opt/lsb/test/lib/libstdcpp_%{version}
%endif
LIBDIR=$RPM_BUILD_ROOT/$EXECROOT
mkdir -p `dirname $LIBDIR`
# SLES10 toolchain bites us again - default is -mlong-double-128
%ifarch ppc ppc64 s390 s390x
PATH=`pwd`:$PATH
cat > lsbc++ << EOF
#!/bin/sh
exec /opt/lsb/bin/lsbc++ -mlong-double-64 \$@
EOF
chmod +x lsbc++
%endif
./build_binary_testsuite $LIBDIR lsbc++ %{_sourcedir} 2>&1 | tee BUILD-DETAILS

SHAREDIR=$RPM_BUILD_ROOT/$PKGROOT
mkdir -p $SHAREDIR
for thing in `cat share-contents`; do
    if [ -d "$thing" ]; then
        cp -r "$thing" "$SHAREDIR/$thing"
    else
        cp "$thing" "$SHAREDIR/$thing"
    fi
done

%ifarch %{ix86}
triplet=i486-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc
triplet=ppc-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc64
triplet=ppc64-unknown-linux-gnu
archlib=lib64
%endif
%ifarch s390
triplet=s390-unknown-linux-gnu
archlib=lib
%endif
%ifarch s390x
triplet=s390x-unknown-linux-gnu
archlib=lib64
%endif
%ifarch ia64
triplet=ia64-unknown-linux-gnu
archlib=lib
%endif
%ifarch x86_64
triplet=x86_64-unknown-linux-gnu
archlib=lib64
%endif

# Create the run_tests file
sed -e "s\\^VERSION=$\\VERSION=%{version}\\" -e "s\\^ARCHLIB=$\\ARCHLIB=$archlib\\" run_tests.in > ${RPM_BUILD_ROOT}/$PKGROOT/run_tests
chmod a+x ${RPM_BUILD_ROOT}/$PKGROOT/run_tests

# Create the context file
sed -e "s\\^V3Test.compiler_output_dir=$\\V3Test.compiler_output_dir=$EXECROOT\\" -e "s\\^DejaGNUTest.target=$\\DejaGNUTest.target=$triplet\\" -e "s\\^VSX_NAME=$\\VSX_NAME=LSB Certification Version %{LSBSpec} (%{_target_cpu})\\" context.in > ${RPM_BUILD_ROOT}/$PKGROOT/context

find $LIBDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f
find $SHAREDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f

# Make sure our build is good - past experience has had 
# missing .exe files, which isn't obvious when one runs the test
# (a missing exe gives a WARNING, not a FAIL)
sed -i "s|lib/libstdcpp|$archlib/libstdcpp|g" exe-files.txt
for exe in `cat exe-files.txt`; do 
  if [ ! -f ${RPM_BUILD_ROOT}/$exe ];then
    echo "Missing test $exe - build terminated..."
    exit 1
  fi
done

# trim out any .cc files that do not have corresponding .exe files
# this way the runtime test result numbers will be more realistic
exedir="${RPM_BUILD_ROOT}/opt/lsb/test/$archlib/libstdcpp_3.4.3"
ccdir="${RPM_BUILD_ROOT}/opt/lsb/test/libstdcpp_3.4.3/testsuite"
for cc in `grep ": PASS" BUILD-DETAILS | grep '\.cc' | awk '{print $1}' | sed 's|:$||g' | sort | uniq`;do
  exe=`echo $cc | sed 's|/|_|g;s|\.cc|.exe|g'`
  exepath="$exedir/_$exe"
  if [ ! -f $exepath ];then                                                    
    echo "missing _$exe ... remove $cc";
    rm -f $ccdir/$cc
  fi;
done

# compiler tests - do not bother with these either, end up as UNTESTED
for cc in `cat compiler-tests.txt`;do
  rm -f $ccdir/$cc
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo 
echo Before running the test script, please figure out the triplet for the
echo system under test. Normally you can use \"gcc -dumpmachine\" to get this.
echo The test script will make a guess which is probably okay, correct it
echo if it is not.  This step cannot be automated as a compiler is not
echo required in the test environment and other methods are imprecise.
echo After this, you can run the test by executing 
echo /opt/lsb/test/libstdcpp_%{version}/run_tests

%files
# Install all files as root:
%defattr(-,root,root)
/opt/lsb/test/libstdcpp_%{version}/
%ifarch ppc64 s390x x86_64
  /opt/lsb/test/lib64/libstdcpp_%{version}/
%else
  /opt/lsb/test/lib/libstdcpp_%{version}
%endif
%doc README
%doc PKGINFO
%doc BUILD-DETAILS
%doc executable-gen.qmr
%doc build_v3_dist
%doc build_binary_testsuite

%changelog
* Wed Apr 25 2007 Stew Benedict
- fix for ppc build (lsbc++ wrapper with -mlong-double-64)
- fix for ia64 build (no -include bits/stdc++.h)
- count .exe files as a sanity check for a "good" build
- refine packaged .cc files so test results reflect what we package

* Sat Mar 31 2007 Mats Wichmann <mats@freestandards.org>
- rename package to lsb-test-libstdcpp, note dependency is now lsb-qm

* Thu Jul 22 2004 Mats Wichmann <mats@freestandards.org>
- rollup changelog for various issues relating to LSB packaging,
  many from Hong Bo Peng
- created baselines for all LSB architectures
- modified v3_test.py to direct all LSB architectures to that set
- added packaging directory with specfile
- added prototype context file, and a run_tests script to execute

* Mon Apr 19 2004 Nathaniel Smith <njs@codesourcery.com> 
- Fix bug in computation of symbol baseline paths.
- Make package relocatable.
- Document generation of new symbol baseline files.
- Update QMTest-related URLs in README.

* Mon Mar 29 2004 Nathaniel Smith <njs@codesourcery.com> 
- Rework for no-compiler version of testsuite.

* Tue Mar 16 2004 Nathaniel Smith <njs@codesourcery.com> 
- Initial release.

